package module.b.ejb;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.WebService;

import module.a.ejb.ADto;
import module.a.ejb.ARemote;

@WebService 
@Stateless
public class BBean implements BLocal, BRemote{
 
	@EJB
	ARemote aRemote;
	
	
	@Override
	public String testIt() {
		System.out.println("Calling asynch method..");
		Future<ADto> futureDto = aRemote.doAsync();
		System.out.println("asynch method called.waiting for response");
		while (!futureDto.isDone()){
			System.out.println("sleeping 500 millis..");
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		System.out.println("ok, now casting with local dto class");
		try {
			ADto wrappedDto = futureDto.get();
			return wrappedDto.getContent();
		} catch (InterruptedException e) {
			throw new RuntimeException(e);
		} catch (ExecutionException e) {
			throw new RuntimeException(e);
		}
		
	}

}
