package module.a.ejb;

import java.util.concurrent.Future;

import javax.ejb.AsyncResult;
import javax.ejb.Asynchronous;
import javax.ejb.Stateless;

@Stateless
public class ABean implements ALocal, ARemote {

	@Asynchronous
	@Override
	public Future<ADto> doAsync() {
		System.out.println("doAsync called. Emulating latency..");
		try {
			Thread.sleep(1500);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		ADto aDto = new ADto();
		aDto.setContent("Content from ABean ejb");
		return new AsyncResult<ADto>(aDto);
	}

}
